  **************************************************************************
  * 			      SineDemo V1.0		  	           *
  **************************************************************************
  *  All code by VECTOR of ALIENATION except skeleton (KillOS, HelpOS)     *
  *  which was kindly supplied by PHOTON of ORACLE (at the time CHAOS).    *
  *  Well up to now I've been learning to code, mainly through looking at  *
  *  other peoples source codes and ripping bits. About 10 minutes ago I   *
  *  got fed up of trying to rip a sine scroller, which used such a wierd  *
  *  way of doing it, so as of now, NO MORE RIPPING - it's all my own!     *
  *  --------------------------------------------------------------------  *
  *  As I learnt to code by ripping, modifying and studying other peoples  *
  *  code, I am going to release this code to my contax to spread freely,  *
  *  in the hope that it might help someone else. Oh well, enough said,    *
  *  on to coding!                                                         *
  *  --------------------------------------------------------------------  *
  *  Initial Idea         :  5th April, 1990.                              *
  *  Coding Started       :  5th April, 1990.                              *
  *  Expected Completion  :  Sometime after exams! Got to revise now!      *
  *  Completed		  :						   *
  **************************************************************************



SineScreen	EQU	$70000
Scroller	EQU	$6FD00
SpeakerScreen	EQU	$75000
PlaneLen	EQU	$2800
TextHeight	EQU	16
WaveAmp		EQU	44
WaveHeight	EQU	WaveAmp*2+TextHeight
WaveMiddle	EQU	WaveAmp

BLTCON0		EQU	$DFF040
BLTCON1		EQU	$DFF042
BLTAFWM		EQU	$DFF044
BLTALWM		EQU	$DFF046
BLTAPT		EQU	$DFF050
BLTBPT		EQU	$DFF04C
BLTDPT		EQU	$DFF054
BLTSIZE		EQU	$DFF058
BLTAMOD		EQU	$DFF064
BLTBMOD		EQU	$DFF062
BLTDMOD		EQU	$DFF066
BLTADAT		EQU	$DFF074
BLTBDAT		EQU	$DFF072
BLTDDAT		EQU	$DFF000
DMACONR		EQU	$DFF002

	SECTION	SINE_DEMO,CODE_C		Force Code Into CHIP RAM

*************************************************************************
*  	  Do All Setting Up, Then Execute Main Program Routines		*
*************************************************************************

Start	MOVEM.L	D0-D7/A0-A6,-(A7)
	MOVE.L	A7,InitialSP
	BSR	KillOS
	BSR	SetUp
	BSR	MkeSine
	BSR	MainRoutine
	BSR	mt_end
	BSR	HelpOS
	MOVE.L	InitialSP,A7
	MOVEM.L	(A7)+,D0-D7/A0-A6
	RTS

*************************************************************************
*	   Turn Off All Multi-Tasking & Operating System Tasks		*
*************************************************************************

KillOS	MOVE.L	$4,A6
	CLR.L	D0
	LEA	GFXLib(PC),A1
	JSR	-552(A6)		_LVOOpenLibrary
	MOVE.L	D0,GFXBase
	JSR	-132(A6)		_LVOForbid
	JSR	-150(A6)		_LVOSuperState
	MOVE.L	D0,SYSStack
	MOVE.W	$DFF01C,IntEnSave
	MOVE.W	$DFF01E,IntRqSave
	MOVE.W	$DFF002,DMASave
	MOVE.W	$DFF010,ADKSave
	MOVE.W	#%0111111111111111,$DFF096	
	MOVE.W	#%0111111111111111,$DFF09A
	MOVE.L	#CopperList,$DFF080
	CLR.W	$DFF088
	MOVE.W	#%1000011111000000,$DFF096
	RTS

************************************************************************
*             Set Up - Clear BitPlanes Used For Display                *
************************************************************************

SetUp	MOVE.L	#SpeakerScreen,A0
	MOVE.L	A0,D0
	LEA	SpeakerPlane,A1
	MOVE.W	#3,D1
SpeakLp	MOVE.W	D0,6(A1)
	SWAP	D0
	MOVE.W	D0,2(A1)
	SWAP	D0
	ADD.L	#1200,D0
	ADDQ.L	#8,A1
	SUBQ.W	#1,D1
	BNE.S	SpeakLp
	MOVE.L	#SineScreen,A0		;load 70000 into a0
	MOVE.L	A0,D0			;change it to data reg
	LEA	SinePlane,A1		;where to place in copper list
	MOVE.W	D0,6(A1)		;write 70000 to copper list
	SWAP	D0
	MOVE.W	D0,2(A1)
	MOVE.W	#$5E10,D0		;clear sine plane + SpeakerPlane
	MOVEQ.W	#0,D1
SineClr	MOVE.W	D1,(A0)+
	DBRA.W	D0,SineClr
	MOVE.L	#Scroller,A0		;clear horiz. scroller memory
	MOVE.W	#$176,D0
	MOVEQ.W	#0,D1
ScrClr	MOVE.W	D1,(A0)+
	DBRA.W	D0,ScrClr	
	MOVE.L	#Text,MessagePos
	MOVE.L	#BCL1,A0
	MOVE.L	#BCL2,A1
	MOVE.L	#BCL3,A2
	MOVE.L	#BCL4,A3
	MOVE.L	#$C001FFFE,D1
	MOVE.L	#$E001FFFE,D2
	MOVE.L	#$0001FFFE,D3
	MOVE.L	#$2001FFFE,D4
	MOVE.L	#$01800000,D5
	MOVE.W	#31,D0
INIT_BARS_LOOP
	MOVE.L	D1,(A0)+
	MOVE.L	D2,(A1)+
	MOVE.L	D3,(A2)+
	MOVE.L	D4,(A3)+
	MOVE.L	D5,(A0)+
	MOVE.L	D5,(A1)+
	MOVE.L	D5,(A2)+
	MOVE.L	D5,(A3)+
	ADD.L	#$01000000,D1
	ADD.L	#$01000000,D2
	ADD.L	#$01000000,D3
	ADD.L	#$01000000,D4
	DBRA	D0,INIT_BARS_LOOP
	MOVE.L	#Effect,A0
	MOVE.L	#$2001FFFE,D0
	MOVE.L	#$01800000,D1
	MOVE.W	#127,D2
EffectL	MOVE.L	D0,(A0)+
	MOVE.L	D1,(A0)+
	ADD.L	#$01000000,D0
	DBRA	D2,EffectL
	JSR	mt_init
	RTS
	
*************************************************************************
*                 Turn Sine Table Into Suitable Sizes                   *
*************************************************************************

MkeSine	LEA.L	SineTable,A0
	MOVE.W	#359,D0
MSine1	MOVEQ.W	#0,D1
	MOVE.W	(A0),D1
	EXT.L	D1
	DIVS	#32767/WaveAmp,D1
	MULS	#40,D1
	MOVE.W	D1,(A0)+
	DBRA	D0,MSine1
	RTS

*************************************************************************
*	   Restore All Multi-Tasking & Operating System Tasks		*
*************************************************************************

HelpOS	MOVE.W	IntEnSave,D7
	BSET	#$F,D7
	MOVE.W	D7,$DFF09A
	MOVE.W	IntRqSave,D7
	BSET	#$F,D7
	MOVE.W	D7,$DFF09C
	MOVE.W	DMASave,D7
	BSET	#$F,D7
	MOVE.W	D7,$DFF096
	MOVE.W	ADKSave,D7
	BSET	#$F,D7
	MOVE.W	D7,$DFF09E
	MOVE.L	GFXBase,A0
	MOVE.L	$26(A0),$DFF080
	MOVE.L	$4,A6
	JSR	-138(A6)		_LVOPermit
	MOVE.L	SYSStack,D0		
	JSR	-156(A6)		_LVOUserState
	RTS

*************************************************************************
*	  Main Program Routine - Selecting of Program to Load		*
*************************************************************************

MainRoutine
	CMPI.B	#200,$DFF006		Check VPOSR For Screen Position
	BNE.S	MainRoutine
	JSR	mt_music
	MOVE.W	EquaBallToggle,D0
	CMP.W	#1,D0
	BNE.S	Next0
	MOVE.W	EveryTwoFrames,D0
	CMP.W	#0,D0
	BNE.S	Sub1
	JSR	MainSpk
	MOVE.W	#2,EveryTwoFrames
	BRA.S	Sub2
Sub1	CMP.W	#1,D0
	BNE.S	Sub2
	MOVE.W	EffectOn,D0
	CMP.W	#1,D0
	BNE.S	Sub2
	JSR	CoolEff
Sub2	SUB.W	#1,EveryTwoFrames
Next0	MOVE.W	SetFade,D0
	CMP.W	#1,D0
	BNE.S	Next1
	JSR	FadeIn
	BRA.S	Next2
Next1	CMP.W	#2,D0
	BNE.S	Next2
	JSR	FadeOut
Next2	MOVE.W	PauseSine,D0
	CMP.W	#0,D0
	BNE.S	SkipScr
	JSR	BltChar
	JSR	ScrMem
	BRA.S	SkipMn
SkipScr	SUBQ.W	#1,D0
	MOVE.W	D0,PauseSine
SkipMn	JSR	DoSine
	JSR	MveWave
	MOVE.W	EquToggle,D0
	CMP.W	#1,D0
	BNE.S	SkipEqu
	JSR	Equaliser
SkipEqu	BTST	#6,$BFE001		Check Left Mouse Button
	BNE	MainRoutine
	RTS

*************************************************************************
*	  New Copper-List to Replace old WorkBench Copper-List		*
*************************************************************************

CopperList
		DC.L	$008E2C81
		DC.L	$00902CC1
		DC.L	$00920038		
		DC.L	$009400D0
		DC.L	$01001200
		DC.L	$01800000
SinePlane	DC.L	$00E00000,$00E20000
SineFade	DC.L	$01820000
Effect		DS.W	512
		DC.L	$01800000
		DC.L	$A501FFFE,$01003200
SpeakerPlane	DC.L	$00E00000,$00E20000,$00E40000,$00E60000
		DC.L	$00E80000,$00EA0000
		DC.L	$01800000,$01820FFF,$018400DD,$018600BB
		DC.L	$01880088,$018A0066,$018C0044,$018E0000
		DC.L	$C301FFFE,$01000200
		DC.L	$01800000,$01820000,$01840000,$01860000
		DC.L	$01880000,$018A0000,$018C0000,$018E0000
BCL1		DS.W	128
BCL2		DS.W	128
		DC.L	$FFE1FFFE
BCL3		DS.W	128
BCL4		DS.W	128
		DC.L	$FFFFFFFE   

************************************************************************
*				Fade In				       *
************************************************************************

FadeIn	MOVE.W	PauseFade,D0
	CMP.W	#4,D0
	BEQ.S	FadeIn1
	ADD.W	#1,PauseFade
	RTS
FadeIn1	LEA	SineFade,A0
	CMP.W	#$0FFF,2(A0)
	BNE.S	FadeIn2
	MOVE.W	#0,SetFade
	RTS
FadeIn2	ADD.W	#$0111,2(A0)
	MOVE.W	#0,PauseFade
	RTS
	
***********************************************************************
*				Fade Out			      *
***********************************************************************

FadeOut	MOVE.W	PauseFade,D0
	CMP.W	#4,D0
	BEQ.S	FdeOut1
	ADD.W	#1,PauseFade
	RTS
FdeOut1	LEA	SineFade,A0
	CMP.W	#$0000,2(A0)
	BNE.S	FdeOut2
	MOVE.W	#0,SetFade
	RTS
FdeOut2	SUB.W	#$0111,2(A0)
	MOVE.W	#0,PauseFade
	RTS
	
*************************************************************************
*  Normal Horizontal Scroller Shift - Used to Take Sine Scroller From   *
*************************************************************************

ScrMem	MOVE.W	#$FFFF,BLTAFWM
	MOVE.W	#$FFFF,BLTALWM
	MOVE.W	#$C9F0,BLTCON0
	MOVE.W	#$0000,BLTCON1
	MOVE.L	#$6FD00,BLTAPT
	MOVE.L	#$6FCFE,BLTDPT
	MOVE.W	#$0000,BLTAMOD
	MOVE.W	#$0000,BLTDMOD
ScrWait	BTST	#14,DMACONR
	BNE.S	ScrWait
	MOVE.W	#(17*64)+22,BLTSIZE
	RTS

************************************************************************
*          Blit Next Character Into Scroll Memory If Needed            *	
************************************************************************

BltChar	SUB.W	#$0001,NextChar
	BEQ.S	YesChar
	RTS

YesChar	MOVE.W	#$0004,NextChar
Again	ADD.L	#1,MessagePos
	MOVE.L	MessagePos,A0
	MOVE.L	#Checker,A1
	CLR.L	D0
	MOVE.B	(A0),D0
	MOVEQ.W	#0,D1
ChkChar	CMP.B	(A1)+,D0
	BEQ	Match
	ADDQ.B	#1,D1
	CMP.B	#46,D1			;fill in number
	BNE.S	ChkChar
	CMP.B	#$FF,D0
	BEQ.S	WrapTxt
	CMP.B	#$FE,D0
	BEQ	Pause
	CMP.B	#$FD,D0
	BNE.S	Tst2
	MOVE.W	#1,SetFade
Tst2	CMP.B	#$FC,D0
	BNE.S	Tst3
	MOVE.W	#2,SetFade
Tst3	CMP.B	#$FB,D0
	BNE.S	Tst4
	MOVE.W	#1,EquToggle
Tst4	CMP.B	#$FA,D0
	BNE.S	Tst5
	MOVE.W	#0,EquToggle
Tst5	CMP.B	#$F9,D0
	BNE.S	Tst6
	MOVE.W	#1,EquaBallToggle
Tst6	CMP.B	#$F8,D0
	BNE.S	Tst7
	MOVE.W	#0,EquaBallToggle
Tst7	CMP.B	#$F7,D0
	BNE.S	Reset
	MOVE.W	#1,EffectOn
Reset	BRA	Again
WrapTxt	MOVE.L	#Text,MessagePos
	BRA	Again	
Match	MOVE.L	D1,D0
	DIVU	#20,D1
	MULU	#640,D1
	ASL	#1,D0
	ADD.L	D1,D0
	MOVE.L	#Font,A0
	ADD.L	D0,A0
	MOVE.L	#$6FD00,A1
	ADD.W	#$2A,A1
DoChar	MOVE.W	#$FFFF,BLTAFWM
	MOVE.W	#$FFFF,BLTALWM
BltWait	BTST	#14,DMACONR
	BNE.S	BltWait
	MOVE.W	#$09F0,BLTCON0
	MOVE.W	#$0000,BLTCON1
	MOVE.L	A0,BLTAPT
	MOVE.L	A1,BLTDPT
	MOVE.W	#$26,BLTAMOD
	MOVE.W	#$2A,BLTDMOD
	MOVE.W	#(16*64)+1,BLTSIZE
	RTS
Pause	MOVE.W	#$A0,PauseSine
	RTS

*************************************************************************
*	    Draw Sine Wave From Hidden Horizontal Scroller		*	
*************************************************************************

DoSine	BSR	DBuffer
	BSR	ClrDraw
	MOVE.W	#$0DFC,BLTCON0
	MOVE.W	#$0000,BLTCON1
	MOVE.W	#$FFFF,BLTALWM
	MOVE.W	#$2A,BLTAMOD
	MOVE.W	#$26,BLTBMOD
	MOVE.W	#$26,BLTDMOD
	MOVE.L	#Scroller+2,D0
	MOVE.L	BufferB,D1
	ADD.L	#WaveMiddle*40,D1
	MOVE.W	#$C000,D2
	MOVE.W	#TextHeight*64+1,D3
	LEA.L	BLTAFWM,A0
	LEA.L	BLTAPT+2,A1
	LEA.L	BLTBPT+2,A2
	LEA.L	BLTDPT+2,A3
	LEA.L	BLTSIZE,A4
	MOVE.L	D0,-2(A1)
	MOVE.L	D1,-2(A2)
	MOVE.L	D1,-2(A3)
	MOVE.L	WaveStart,A5
	MOVE.L	#EndOfSineTable,D7
	MOVEQ.W	#19,D4
DoSine1	MOVEQ.W	#7,D5
DoSine2	MOVE.W	D1,D6
	ADD.W	(A5)+,D6
	CMP.L	D7,A5
	BNE.S	DoSine3
	LEA.L	SineTable,A5
DoSine3	MOVE.W	D0,(A1)
	MOVE.W	D6,(A2)
	MOVE.W	D6,(A3)
	MOVE.W	D2,(A0)
	MOVE.W	D3,(A4)
	ROR.W	#2,D2
	DBRA	D5,DoSine2
	ADDQ.L	#2,D0
	ADDQ.L	#2,D1
	DBRA	D4,DoSine1
	RTS
	
*************************************************************************
*			Scroll Sine Wave Along			        *
*************************************************************************

MveWave	MOVE.L	WaveStart,D0
	MOVE.L	WaveSpeed,D1
	ASL.L	#1,D1
	ADD.L	D1,D0
	CMP.L	#SineTable-2,D0
	BLS	MWave2
	CMP.L	#EndOfSineTable-4,D0
	BLS	MWave1
	SUB.L	#360*2,D0
MWave1	MOVE.L	D0,WaveStart
	RTS
MWave2	ADD.L	#360*2,D0
	MOVE.L	D0,WaveStart
	RTS
	
*************************************************************************
* Double Buffer Sine Plane So That One Is Displayed Whilst The Other Is *
*          Being Drawn. Also Clear Plane To Be Drawn On To.             *
*************************************************************************

DBuffer	MOVE.L	BufferA,A0
	MOVE.L	BufferB,A1
	MOVE.L	A1,BufferA
	MOVE.L	A0,BufferB
	MOVE.L	A0,D0
	LEA	SinePlane,A0
	MOVE.W	D0,6(A0)
	SWAP	D0
	MOVE.W	D0,2(A0)
	RTS
	
ClrDraw	MOVE.W	#$FFFF,BLTAFWM
	MOVE.W	#$FFFF,BLTALWM
	MOVE.W	#$0000,BLTAMOD
	MOVE.W	#$0000,BLTDMOD
ClrBlt	MOVE.W	#$01F0,BLTCON0
	MOVE.W	#$0000,BLTCON1
	MOVE.L	BufferB,D0
	ADD.L	#(WaveMiddle-WaveAmp)*40,D0
	MOVE.L	D0,BLTDPT
	MOVE.W	#$0000,BLTADAT
	MOVE.W	#(WaveHeight*64)+20,BLTSIZE
BWait	BTST	#14,DMACONR
	BNE.S	BWait
	RTS	

*******************************************************************
*  R F                  EQUA-BARS SUBROUTINE                 R F  *
*******************************************************************

Equaliser
	MOVE.L	BARPTR,D0
	CMP.L 	#$00000000,BARPTR
	BEQ.S	NEXT1
	MOVE.L	BARPTR,D0
	LEA	BARCOL1,A0
	LEA	BCL1,A1
	ADD.L	D0,A0
	MOVE.W	#$000F,D0
LOOP	MOVE.W	2(A0),6(A1)
	ADD.L	#8,A1
	ADD.L	#2,A0
	DBF	D0,LOOP
	MOVE.W	#$000F,D0
LOOPA	MOVE.W	2(A0),6(A1)
	ADD.L	#8,A1
	SUB.L	#2,A0
	DBF	D0,LOOPA
	SUB.L	#2,BARPTR
NEXT1	MOVE.L	BARPTR+4,D0
	CMP.L 	#$00000000,BARPTR+4
	BEQ.S	NEXT2
	MOVE.L	BARPTR+4,D0
	LEA	BARCOL2,A0
	LEA	BCL2,A1
	ADD.L	D0,A0
	MOVE.W	#$000F,D0
LOOP1	MOVE.W	2(A0),6(A1)
	ADD.L	#8,A1
	ADD.L	#2,A0
	DBF	D0,LOOP1
	MOVE.W	#$000F,D0
LOOP1A	MOVE.W	2(A0),6(A1)
	ADD.L	#8,A1
	SUB.L	#2,A0
	DBF	D0,LOOP1A
	SUB.L	#2,BARPTR+4
NEXT2	MOVE.L	BARPTR+8,D0
	CMP.L 	#$00000000,BARPTR+8
	BEQ.S	NEXT3
	MOVE.L	BARPTR+8,D0
	LEA	BARCOL3,A0
	LEA	BCL3,A1
	ADD.L	D0,A0
	MOVE.W	#$000F,D0
LOOP2	MOVE.W	2(A0),6(A1)
	ADD.L	#8,A1
	ADD.L	#2,A0
	DBF	D0,LOOP2
	MOVE.W	#$000F,D0
LOOP2A	MOVE.W	2(A0),6(A1)
	ADD.L	#8,A1
	SUB.L	#2,A0
	DBF	D0,LOOP2A
	SUB.L	#2,BARPTR+8
NEXT3	MOVE.L	BARPTR+12,D0
	CMP.L 	#$00000000,BARPTR+12
	BEQ.S	NEXT4
	MOVE.L	BARPTR+12,D0
	LEA	BARCOL4,A0
	LEA	BCL4,A1
	ADD.L	D0,A0
	MOVE.W	#$000F,D0
LOOP3	MOVE.W	2(A0),6(A1)
	ADD.L	#8,A1
	ADD.L	#2,A0
	DBF	D0,LOOP3
	MOVE.W	#$000F,D0
LOOP3A	MOVE.W	2(A0),6(A1)
	ADD.L	#8,A1
	SUB.L	#2,A0
	DBF	D0,LOOP3A
	SUB.L	#2,BARPTR+12
NEXT4	RTS

******************************************************************
*		Animated Ball Effect As Equaliser!		 *
******************************************************************

MainSpk	MOVE.L	SpeakerPointer,D0
	CMP.L	#0,D0
	BEQ.S	Spk2
	MOVE.W	#0,HorizOffset
	MOVE.W	D0,BallNo
	JSR	Speaker
	MOVE.W	#36,HorizOffset
	JSR	Speaker
	SUB.L	#4,SpeakerPointer
Spk2	MOVE.L	SpeakerPointer+4,D0
	CMP.L	#0,D0
	BEQ.S	Spk3
	MOVE.W	#4,HorizOffset
	MOVE.W	D0,BallNo
	JSR	Speaker
	MOVE.W	#32,HorizOffset
	JSR	Speaker
	SUB.L	#4,SpeakerPointer+4
Spk3	MOVE.L	SpeakerPointer+8,D0
	CMP.L	#0,D0
	BEQ.S	Spk4
	MOVE.W	#8,HorizOffset
	MOVE.W	D0,BallNo
	JSR	Speaker
	MOVE.W	#28,HorizOffset
	JSR	Speaker
	SUB.L	#4,SpeakerPointer+8
Spk4	MOVE.L	SpeakerPointer+12,D0
	CMP.L	#0,D0
	BEQ.S	SpkFin
	MOVE.W	#12,HorizOffset
	MOVE.W	D0,BallNo
	JSR	Speaker
	MOVE.W	#24,HorizOffset
	JSR	Speaker
	SUB.L	#4,SpeakerPointer+12
SpkFin	RTS

Speaker	MOVE.L	#$75000,A0
	LEA	Balls,A1
	MOVE.W	BallNo,D1
	ADD.W	D1,A1
	MOVE.W	HorizOffset,D3
	ADD.W	D3,A0
	MOVE.W	#$FFFF,BLTAFWM
	MOVE.W	#$FFFF,BLTALWM
	MOVE.W	#3,D2
WaitSpk	BTST	#14,DMACONR
	BNE.S	WaitSpk
	MOVE.W	#$09F0,BLTCON0
	MOVE.W	#$0000,BLTCON1
	MOVE.W	#$24,BLTAMOD
	MOVE.W	#$24,BLTDMOD
	MOVE.L	A1,BLTAPT
	MOVE.L	A0,BLTDPT
	MOVE.W	#(30*64)+2,BLTSIZE
	ADD.L	#1200,A0
	ADD.L	#1200,A1
	SUBQ.W	#1,D2
	BNE.S	WaitSpk
	RTS

******************************************************************
*		The Coolest Copper Effect Ever!			 *
******************************************************************

CoolEff	LEA	Effect,A0
	MOVE.L	EffectOffset,D0
	CMP.L	#$1A0,D0
	BNE.S	DoEff
	MOVE.L	#0,EffectOffset
	RTS
	
DoEff	MOVE.W	#15,D1
	MOVE.L	EffectOffset,D0
Efflp1	LEA	EffectPointer,A1
	ADD.L	D0,A1
	MOVE.W	#7,D2
Efflp2	MOVE.W	(A1),6(A0)
	ADD.L	#8,A0
	ADD.L	#2,A1
	DBF	D2,Efflp2
	ADD.L	#2,D0	
	DBF	D1,Efflp1
	ADD.L	#2,EffectOffset
	RTS
	
******************************************************************
*          Yeah! Can't get better than NoiseTracker! 		 *
******************************************************************

;
;   NoisetrackerV1.0 replayroutine   
; Mahoney & Kaktus - HALLONSOFT 1989 
;



mt_init:lea	mt_data,a0
	move.l	a0,a1
	add.l	#$3b8,a1
	moveq	#$7f,d0
	moveq	#0,d1
mt_loop:move.l	d1,d2
	subq.w	#1,d0
mt_lop2:move.b	(a1)+,d1
	cmp.b	d2,d1
	bgt.s	mt_loop
	dbf	d0,mt_lop2
	addq.b	#1,d2

	lea	mt_samplestarts(pc),a1
	asl.l	#8,d2
	asl.l	#2,d2
	add.l	#$43c,d2
	add.l	a0,d2
	move.l	d2,a2
	moveq	#$1e,d0
mt_lop3:clr.l	(a2)
	move.l	a2,(a1)+
	moveq	#0,d1
	move.w	42(a0),d1
	asl.l	#1,d1
	add.l	d1,a2
	add.l	#$1e,a0
	dbf	d0,mt_lop3

	or.b	#$2,$bfe001
	move.b	#$6,mt_speed
	clr.w	$dff0a8
	clr.w	$dff0b8
	clr.w	$dff0c8
	clr.w	$dff0d8
	clr.b	mt_songpos
	clr.b	mt_counter
	clr.w	mt_pattpos
	rts

mt_end:	clr.w	$dff0a8
	clr.w	$dff0b8
	clr.w	$dff0c8
	clr.w	$dff0d8
	move.w	#$f,$dff096
	rts

mt_music:
	movem.l	d0-d4/a0-a3/a5-a6,-(a7)
	MOVE.L	#$00000000,PLACE
	lea	mt_data,a0
	addq.b	#$1,mt_counter
	move.b	mt_counter,D0
	cmp.b	mt_speed,D0
	blt.s	mt_nonew
	clr.b	mt_counter
	bra	mt_getnew

mt_nonew:
	lea	mt_voice1(pc),a6
	lea	$dff0a0,a5
	bsr	mt_checkcom
	lea	mt_voice2(pc),a6
	lea	$dff0b0,a5
	bsr	mt_checkcom
	lea	mt_voice3(pc),a6
	lea	$dff0c0,a5
	bsr	mt_checkcom
	lea	mt_voice4(pc),a6
	lea	$dff0d0,a5
	bsr	mt_checkcom
	bra	mt_endr

mt_arpeggio:
	moveq	#0,d0
	move.b	mt_counter,d0
	divs	#$3,d0
	swap	d0
	cmp.w	#$0,d0
	beq.s	mt_arp2
	cmp.w	#$2,d0
	beq.s	mt_arp1

	moveq	#0,d0
	move.b	$3(a6),d0
	lsr.b	#4,d0
	bra.s	mt_arp3
mt_arp1:moveq	#0,d0
	move.b	$3(a6),d0
	and.b	#$f,d0
	bra.s	mt_arp3
mt_arp2:move.w	$10(a6),d2
	bra.s	mt_arp4
mt_arp3:asl.w	#1,d0
	moveq	#0,d1
	move.w	$10(a6),d1
	lea	mt_periods(pc),a0
	moveq	#$24,d7
mt_arploop:
	move.w	(a0,d0.w),d2
	cmp.w	(a0),d1
	bge.s	mt_arp4
	addq.l	#2,a0
	dbf	d7,mt_arploop
	rts
mt_arp4:move.w	d2,$6(a5)
	rts

mt_getnew:
	lea	mt_data,a0
	move.l	a0,a3
	move.l	a0,a2
	add.l	#$c,a3
	add.l	#$3b8,a2
	add.l	#$43c,a0

	moveq	#0,d0
	move.l	d0,d1
	move.b	mt_songpos,d0
	move.b	(a2,d0.w),d1
	asl.l	#8,d1
	asl.l	#2,d1
	add.w	mt_pattpos,d1
	clr.w	mt_dmacon

	lea	$dff0a0,a5
	lea	mt_voice1(pc),a6
	bsr.s	mt_playvoice
	ADD.L	#4,PLACE
	lea	$dff0b0,a5
	lea	mt_voice2(pc),a6
	bsr.s	mt_playvoice
	ADD.L	#4,PLACE
	lea	$dff0c0,a5
	lea	mt_voice3(pc),a6
	bsr.s	mt_playvoice
	ADD.L	#4,PLACE
	lea	$dff0d0,a5
	lea	mt_voice4(pc),a6
	bsr.s	mt_playvoice
	bra	mt_setdma

mt_playvoice:
	move.l	(a0,d1.l),(a6)
	addq.l	#4,d1
	moveq	#0,d2
	move.b	$2(a6),d2
	and.b	#$f0,d2
	lsr.b	#4,d2
	move.b	(a6),d0
	and.b	#$f0,d0
	or.b	d0,d2
	tst.b	d2
	beq.s	mt_setregs
	moveq	#0,d3
	lea	mt_samplestarts(pc),a1
	move.l	d2,d4
	subq.l	#$1,d2
	asl.l	#2,d2
	mulu	#$1e,d4
	move.l	(a1,d2.l),$4(a6)
	move.w	(a3,d4.l),$8(a6)
	move.w	$2(a3,d4.l),$12(a6)
	move.w	$4(a3,d4.l),d3
	tst.w	d3
	beq.s	mt_noloop
	move.l	$4(a6),d2
	asl.w	#1,d3
	add.l	d3,d2
	move.l	d2,$a(a6)
	move.w	$4(a3,d4.l),d0
	add.w	$6(a3,d4.l),d0
	move.w	d0,8(a6)
	move.w	$6(a3,d4.l),$e(a6)
	move.w	$12(a6),$8(a5)
	bra.s	mt_setregs
mt_noloop:
	move.l	$4(a6),d2
	add.l	d3,d2
	move.l	d2,$a(a6)
	move.w	$6(a3,d4.l),$e(a6)
	move.w	$12(a6),$8(a5)
mt_setregs:
	move.w	(a6),d0
	and.w	#$fff,d0
	beq	mt_checkcom2
	move.b	$2(a6),d0
	and.b	#$F,d0
	cmp.b	#$3,d0
	bne.s	mt_setperiod
	bsr	mt_setmyport
	bra	mt_checkcom2
mt_setperiod:
	LEA	BARPTR,A4
	ADD.L	PLACE,A4
	MOVE.L	#$001C,(A4)
	LEA	SpeakerPointer,A4
	ADD.L	PLACE,A4
	MOVE.L	#$001C,(A4)
	move.w	(a6),$10(a6)
	and.w	#$fff,$10(a6)
	move.w	$14(a6),d0
	move.w	d0,$dff096
	clr.b	$1b(a6)
	move.l	$4(a6),(a5)
	move.w	$8(a6),$4(a5)
	move.w	$10(a6),d0
	and.w	#$fff,d0
	move.w	d0,$6(a5)
	move.w	$14(a6),d0
	or.w	d0,mt_dmacon
	bra	mt_checkcom2

mt_setdma:
	move.w	#$12c,d0
mt_wait:dbf	d0,mt_wait
	move.w	mt_dmacon,d0
	or.w	#$8000,d0
	move.w	d0,$dff096
	move.w	#$12c,d0
mt_wai2:dbf	d0,mt_wai2
	lea	$dff000,a5
	lea	mt_voice4(pc),a6
	move.l	$a(a6),$d0(a5)
	move.w	$e(a6),$d4(a5)
	lea	mt_voice3(pc),a6
	move.l	$a(a6),$c0(a5)
	move.w	$e(a6),$c4(a5)
	lea	mt_voice2(pc),a6
	move.l	$a(a6),$b0(a5)
	move.w	$e(a6),$b4(a5)
	lea	mt_voice1(pc),a6
	move.l	$a(a6),$a0(a5)
	move.w	$e(a6),$a4(a5)

	add.w	#$10,mt_pattpos
	cmp.w	#$400,mt_pattpos
	bne.s	mt_endr
mt_nex:	clr.w	mt_pattpos
	clr.b	mt_break
	addq.b	#1,mt_songpos
	and.b	#$7f,mt_songpos
	move.b	mt_songpos,d1
	cmp.b	mt_data+$3b6,d1
	bne.s	mt_endr
	clr.b	mt_songpos
mt_endr:tst.b	mt_break
	bne.s	mt_nex
	movem.l	(a7)+,d0-d4/a0-a3/a5-a6
	rts

mt_setmyport:
	move.w	(a6),d2
	and.w	#$fff,d2
	move.w	d2,$18(a6)
	move.w	$10(a6),d0
	clr.b	$16(a6)
	cmp.w	d0,d2
	beq.s	mt_clrport
	bge.s	mt_rt
	move.b	#$1,$16(a6)
	rts
mt_clrport:
	clr.w	$18(a6)
mt_rt:	rts

mt_myport:
	move.b	$3(a6),d0
	beq.s	mt_myslide
	move.b	d0,$17(a6)
	clr.b	$3(a6)
mt_myslide:
	tst.w	$18(a6)
	beq.s	mt_rt
	moveq	#0,d0
	move.b	$17(a6),d0
	tst.b	$16(a6)
	bne.s	mt_mysub
	add.w	d0,$10(a6)
	move.w	$18(a6),d0
	cmp.w	$10(a6),d0
	bgt.s	mt_myok
	move.w	$18(a6),$10(a6)
	clr.w	$18(a6)
mt_myok:move.w	$10(a6),$6(a5)
	rts
mt_mysub:
	sub.w	d0,$10(a6)
	move.w	$18(a6),d0
	cmp.w	$10(a6),d0
	blt.s	mt_myok
	move.w	$18(a6),$10(a6)
	clr.w	$18(a6)
	move.w	$10(a6),$6(a5)
	rts

mt_vib:	move.b	$3(a6),d0
	beq.s	mt_vi
	move.b	d0,$1a(a6)

mt_vi:	move.b	$1b(a6),d0
	lea	mt_sin(pc),a4
	lsr.w	#$2,d0
	and.w	#$1f,d0
	moveq	#0,d2
	move.b	(a4,d0.w),d2
	move.b	$1a(a6),d0
	and.w	#$f,d0
	mulu	d0,d2
	lsr.w	#$6,d2
	move.w	$10(a6),d0
	tst.b	$1b(a6)
	bmi.s	mt_vibmin
	add.w	d2,d0
	bra.s	mt_vib2
mt_vibmin:
	sub.w	d2,d0
mt_vib2:move.w	d0,$6(a5)
	move.b	$1a(a6),d0
	lsr.w	#$2,d0
	and.w	#$3c,d0
	add.b	d0,$1b(a6)
	rts

mt_nop:	move.w	$10(a6),$6(a5)
	rts

mt_checkcom:
	move.w	$2(a6),d0
	and.w	#$fff,d0
	beq.s	mt_nop
	move.b	$2(a6),d0
	and.b	#$f,d0
	tst.b	d0
	beq	mt_arpeggio
	cmp.b	#$1,d0
	beq.s	mt_portup
	cmp.b	#$2,d0
	beq	mt_portdown
	cmp.b	#$3,d0
	beq	mt_myport
	cmp.b	#$4,d0
	beq	mt_vib
	move.w	$10(a6),$6(a5)
	cmp.b	#$a,d0
	beq.s	mt_volslide
	rts

mt_volslide:
	moveq	#0,d0
	move.b	$3(a6),d0
	lsr.b	#4,d0
	tst.b	d0
	beq.s	mt_voldown
	add.w	d0,$12(a6)
	cmp.w	#$40,$12(a6)
	bmi.s	mt_vol2
	move.w	#$40,$12(a6)
mt_vol2:move.w	$12(a6),$8(a5)
	rts

mt_voldown:
	moveq	#0,d0
	move.b	$3(a6),d0
	and.b	#$f,d0
	sub.w	d0,$12(a6)
	bpl.s	mt_vol3
	clr.w	$12(a6)
mt_vol3:move.w	$12(a6),$8(a5)
	rts

mt_portup:
	moveq	#0,d0
	move.b	$3(a6),d0
	sub.w	d0,$10(a6)
	move.w	$10(a6),d0
	and.w	#$fff,d0
	cmp.w	#$71,d0
	bpl.s	mt_por2
	and.w	#$f000,$10(a6)
	or.w	#$71,$10(a6)
mt_por2:move.w	$10(a6),d0
	and.w	#$fff,d0
	move.w	d0,$6(a5)
	rts

mt_portdown:
	clr.w	d0
	move.b	$3(a6),d0
	add.w	d0,$10(a6)
	move.w	$10(a6),d0
	and.w	#$fff,d0
	cmp.w	#$358,d0
	bmi.s	mt_por3
	and.w	#$f000,$10(a6)
	or.w	#$358,$10(a6)
mt_por3:move.w	$10(a6),d0
	and.w	#$fff,d0
	move.w	d0,$6(a5)
	rts

mt_checkcom2:
	move.b	$2(a6),d0
	and.b	#$f,d0
	cmp.b	#$e,d0
	beq.s	mt_setfilt
	cmp.b	#$d,d0
	beq.s	mt_pattbreak
	cmp.b	#$b,d0
	beq.s	mt_posjmp
	cmp.b	#$c,d0
	beq.s	mt_setvol
	cmp.b	#$f,d0
	beq.s	mt_setspeed
	rts

mt_setfilt:
	rts
mt_pattbreak:
	not.b	mt_break
	rts
mt_posjmp:
	move.b	$3(a6),d0
	subq.b	#$1,d0
	move.b	d0,mt_songpos
	not.b	mt_break
	rts
mt_setvol:
	cmp.b	#$40,$3(a6)
	ble.s	mt_vol4
	move.b	#$40,$3(a6)
mt_vol4:move.b	$3(a6),$8(a5)
	rts
mt_setspeed:
	move.b	$3(a6),d0
	and.w	#$1f,d0
	beq.s	mt_rts2
	clr.b	mt_counter
	move.b	d0,mt_speed
mt_rts2:rts




mt_sin:
 dc.b $00,$18,$31,$4a,$61,$78,$8d,$a1,$b4,$c5,$d4,$e0,$eb,$f4,$fa,$fd
 dc.b $ff,$fd,$fa,$f4,$eb,$e0,$d4,$c5,$b4,$a1,$8d,$78,$61,$4a,$31,$18

mt_periods:
 dc.w $0358,$0328,$02fa,$02d0,$02a6,$0280,$025c,$023a,$021a,$01fc,$01e0
 dc.w $01c5,$01ac,$0194,$017d,$0168,$0153,$0140,$012e,$011d,$010d,$00fe
 dc.w $00f0,$00e2,$00d6,$00ca,$00be,$00b4,$00aa,$00a0,$0097,$008f,$0087
 dc.w $007f,$0078,$0071,$0000,$0000

mt_speed:	dc.b	$6
mt_songpos:	dc.b	$0
mt_pattpos:	dc.w	$0
mt_counter:	dc.b	$0

mt_break:	dc.b	$0
mt_dmacon:	dc.w	$0
mt_samplestarts:dcb.l	$1f,0
mt_voice1:	dcb.w	10,0
		dc.w	$1
		dcb.w	3,0
mt_voice2:	dcb.w	10,0
		dc.w	$2
		dcb.w	3,0
mt_voice3:	dcb.w	10,0
		dc.w	$4
		dcb.w	3,0
mt_voice4:	dcb.w	10,0
		dc.w	$8
		dcb.w	3,0


BARPTR		DC.L	$0016,$0016,$0016,$0016
BARCOL1		DC.W	$000,$000,$000,$000,$000,$000,$000,$000
		DC.W	$000,$000,$000,$000,$000,$000,$000,$000
		DC.W	$000,$200,$300,$400,$500,$600,$700,$800
		DC.W	$900,$A00,$B00,$C00,$D00,$E00,$F00,$F00
BARCOL2		DC.W	$000,$000,$000,$000,$000,$000,$000,$000
		DC.W	$000,$000,$000,$000,$000,$000,$000,$000
		DC.W	$000,$020,$030,$040,$050,$060,$070,$080
		DC.W	$090,$0A0,$0B0,$0C0,$0D0,$0E0,$0F0,$0F0
BARCOL3		DC.W	$000,$000,$000,$000,$000,$000,$000,$000
		DC.W	$000,$000,$000,$000,$000,$000,$000,$000
		DC.W	$000,$220,$330,$440,$550,$660,$770,$880
		DC.W	$990,$AA0,$BB0,$CC0,$DD0,$EE0,$FF0,$FF0
BARCOL4		DC.W	$000,$000,$000,$000,$000,$000,$000,$000
		DC.W	$000,$000,$000,$000,$000,$000,$000,$000
		DC.W	$000,$002,$003,$004,$005,$006,$007,$008
		DC.W	$009,$00A,$00B,$00C,$00D,$00E,$00F,$00F
PLACE		DC.L	$00000000
SpeakerPointer	DC.L	$001C,$001C,$001C,$001C

*************************************************************************
*	 Variables and Data Tables used throughout the program		*
************************************************************************

SYSStack	DC.L	0
GFXBase		DC.L	0
InitialSP	DC.L	0
IntEnSave	DC.W	0	
IntRqSave	DC.W	0
DMASave		DC.W	0
ADKSave		DC.W	0
Frame		DC.W	0
NextChar	DC.W	4
MessagePos	DC.L	0
WaveStart	DC.L	SineTable
WaveSpeed	DC.L	-3
PauseSine	DC.W	0
PauseFade	DC.W	4
SetFade		DC.W	0
EquToggle	DC.W	0
EquaBallToggle	DC.W	0
BufferA		DC.L	SineScreen
BufferB		DC.L	SineScreen+PlaneLen
SpeakerPos	DC.W	28
SpeakerSlow	DC.W	3
BallNo		DC.W	0
HorizOffset	DC.W	4
EveryTwoFrames	DC.W	2
EffectOffset	DC.L	0
EffectOn	DC.W	0
EffectPointer	DC.W	$000,$000,$000,$000,$000,$000,$000,$000
		DC.W	$000,$000,$000,$000,$000,$000,$000,$000
		DC.W	$001,$002,$003,$004,$005,$006,$007,$008
		DC.W	$009,$00A,$00B,$00C,$00D,$00E,$00F,$00E
		DC.W	$00D,$00C,$00B,$00A,$009,$008,$007,$006
		DC.W	$005,$004,$003,$002,$001,$000,$000,$000
		DC.W	$000,$000,$000,$000,$000,$000,$000,$000
		DC.W	$000,$000,$000,$000,$000,$000,$000,$000
		DC.W	$000,$000,$000,$000,$000,$000,$000,$000
		DC.W	$000,$000,$000,$000,$000,$000,$000,$000
		DC.W	$110,$220,$330,$440,$550,$660,$770,$880
		DC.W	$990,$AA0,$BB0,$CC0,$DD0,$EE0,$FF0,$EE0
		DC.W	$DD0,$CC0,$BB0,$AA0,$990,$880,$770,$660
		DC.W	$550,$440,$330,$220,$110,$000,$000,$000
		DC.W	$000,$000,$000,$000,$000,$000,$000,$000
		DC.W	$000,$000,$000,$000,$000,$000,$000,$000
		DC.W	$000,$000,$000,$000,$000,$000,$000,$000
		DC.W	$000,$000,$000,$000,$000,$000,$000,$000
		DC.W	$010,$020,$030,$040,$050,$060,$070,$080
		DC.W	$090,$0A0,$0B0,$0C0,$0D0,$0E0,$0F0,$0E0
		DC.W	$0D0,$0C0,$0B0,$0A0,$090,$080,$070,$060
		DC.W	$050,$040,$030,$020,$010,$000,$000,$000
		DC.W	$000,$000,$000,$000,$000,$000,$000,$000
		DC.W	$000,$000,$000,$000,$000,$000,$000,$000
		DC.W	$000,$000,$000,$000,$000,$000,$000,$000
		DC.W	$000,$000,$000,$000,$000,$000,$000,$000
		DC.W	$000,$000,$000,$000,$000,$000,$000,$000
		DC.W	$000,$000,$000,$000,$000,$000,$000,$000
		DC.W	$000,$000,$000,$000,$000,$000,$000,$000
		DC.W	$000,$000,$000,$000,$000,$000,$000,$000
		DC.W	$000,$000,$000,$000,$000,$000,$000,$000
		DC.W	$000,$000,$000,$000,$000,$000,$000,$000
		DC.W	$000,$000,$000,$000,$000,$000,$000,$000
		DC.W	$000,$000,$000,$000,$000,$000,$000,$000
GFXLib		DC.B	"graphics.library",0,0
 even
Checker		DC.B	"ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789? .!()':-,"
Text		DC.B	$00,$FD,$FE,"WATCH CAREFULLY     "
		DC.B	$FC,"                 - DR. SAD -    ",$FD,$FE
		DC.B	"   BECAUSE THIS IS MY SECOND EVER DEMO, NOW ON SHOW TO YOU! SO LET THIS "
		DC.B	"DEMO COMMENCE WITH SOME EQUA-BALLS!  ",$F9," AND NOW TO GO WITH THESE "
		DC.B	"EQUA-BALLS ----------------------------------------- A 4 CHANEL STEREO "
		DC.B	"EQUALISER!    ",$FB," WOW! IS THAT IT? -------------- NOT QUITE! SO HERE "
		DC.B	"IS THE LAST BIT (FOR NOW!) ------ ",$F7
		DC.B	"       OK, THATS IT FOR NOW! THERE'S SPACE DOWN BELOW FOR A DECENT "
		DC.B	"SIZED LOGO. LET ME KNOW WHAT YOU THINK OF THIS!                 "
		DC.B	" ALL "
		DC.B	"CODING BY       - VECTOR -     ",$FE,"                ",$FF

* FF = Wrap ScrollText Back To Start
* FE = Pause Scrolltext For Approx 1 Second
* FD = Fade in Sine Scroller 
* FC = Fade Out Sine Scroller
* FB = Turn On Equaliser
* FA = Turn Off Equaliser
* F9 = Turn On Equa-Balls
* F8 = Turn Off Equa-Balls
* F7 = Turn On Cool Effect
 
 even	

SineTable	DC.W	0					0

		DC.W	571,1143,1714,2285,2855,3425
		DC.W	3993,4560,5125,5689,6252,6812
		DC.W	7370,7927,8480,9031,9580,10125
		DC.W	10667,11206,11742,12274,12803,13327
		DC.W	13847,14364,14875,15383,15885,16383
		DC.W	16876,17363,17846,18323,18794,19259
		DC.W	19719,20173,20620,21062,21497,21925
		DC.W	22347,22761,23169,23570,23964,24350
		DC.W	24729,25100,25464,25820,26168,26509
		DC.W	26841,27165,27480,27787,28086,28377
		DC.W	28658,28931,29195,29450,29696,29934
		DC.W	30162,30381,30590,30790,30981,31163
		DC.W	31335,31497,31650,31793,31927,32050
		DC.W	32164,32269,32363,32448,32522,32587
		DC.W	32642,32687,32722,32747,32762

		DC.W	32767					90

		DC.W	32762,32747,32722,32687,32642		91
		DC.W	32587,32522,32448,32363,32269,32164
		DC.W	32050,31927,31793,31650,31497,31335
		DC.W	31163,30981,30790,30590,30381,30162
		DC.W	29934,29696,29450,29195,28931,28658
		DC.W	28377,28086,27787,27480,27165,26841
		DC.W	26509,26168,25820,25464,25100,24729
		DC.W	24350,23964,23570,23169,22761,22347
		DC.W	21925,21497,21062,20620,20173,19719
		DC.W	19259,18794,18323,17846,17363,16876
		DC.W	16383,15885,15383,14875,14364,13847
		DC.W	13327,12803,12274,11742,11206,10667
		DC.W	10125,9580,9031,8480,7927,7370
		DC.W	6812,6252,5689,5125,4560,3993
		DC.W	3425,2855,2285,1714,1143,571

		DC.W	0					180

		DC.W	-571,-1143,-1714,-2285,-2855,-3425		
		DC.W	-3993,-4560,-5125,-5689,-6252,-6812
		DC.W	-7370,-7927,-8480,-9031,-9580,-10125
		DC.W	-10667,-11206,-11742,-12274,-12803,-13327
		DC.W	-13847,-14364,-14875,-15383,-15885,-16383
		DC.W	-16876,-17363,-17846,-18323,-18794,-19259
		DC.W	-19719,-20173,-20620,-21062,-21497,-21925
		DC.W	-22347,-22761,-23169,-23570,-23964,-24350
		DC.W	-24729,-25100,-25464,-25820,-26168,-26509
		DC.W	-26841,-27165,-27480,-27787,-28086,-28377
		DC.W	-28658,-28931,-29195,-29450,-29696,-29934
		DC.W	-30162,-30381,-30590,-30790,-30981,-31163
		DC.W	-31335,-31497,-31650,-31793,-31927,-32050
		DC.W	-32164,-32269,-32363,-32448,-32522,-32587
		DC.W	-32642,-32687,-32722,-32747,-32762

		DC.W	-32767					270

		DC.W	-32762,-32747,-32722,-32687,-32642
		DC.W	-32587,-32522,-32448,-32363,-32269,-32164
		DC.W	-32050,-31927,-31793,-31650,-31497,-31335
		DC.W	-31163,-30981,-30790,-30590,-30381,-30162
		DC.W	-29934,-29696,-29450,-29195,-28931,-28658
		DC.W	-28377,-28086,-27787,-27480,-27165,-26841
		DC.W	-26509,-26168,-25820,-25464,-25100,-24729
		DC.W	-24350,-23964,-23570,-23169,-22761,-22347
		DC.W	-21925,-21497,-21062,-20620,-20173,-19719
		DC.W	-19259,-18794,-18323,-17846,-17363,-16876
		DC.W	-16383,-15885,-15383,-14875,-14364,-13847
		DC.W	-13327,-12803,-12274,-11742,-11206,-10667
		DC.W	-10125,-9580,-9031,-8480,-7927,-7370
		DC.W	-6812,-6252,-5689,-5125,-4560,-3993
		DC.W	-3425,-2855,-2285,-1714,-1143,-571		Last is 359
EndOfSineTable

*************************************************************************
*	       Include Files And Data Blocks Placed Below		*
*************************************************************************

Font		INCBIN	"FONT.BIN"
Balls		INCBIN	"Ball_Anim.BIN"
mt_data		INCBIN	"MOD.TRUE FAITH"
